<?php
function html_print_r() {
	$prefix = '';
	$depth = 0;
	$args = func_get_args();
	$return = false;
	
	if (func_num_args() == 4) {
		$prefix = $args[0];
		$arr = $args[1];
		$return = $args[2];
		$depth = $args[3];		
	}
	elseif (func_num_args() == 3) {
		$prefix = $args[0];
		$arr = $args[1];
		$return = $args[2];
	}
	elseif (func_num_args() == 2) {
		if (is_bool($args[1])) {
			$arr = $args[0];
			$return = $args[1];
		}
		else {
			$prefix = $args[0];
			$arr = $args[1];
		}
	}
	else {
		$arr = $args[0];
	}
	
	$out = '';
	if (!isset($arr)) {
		$out .= "Array not set<br>\n";	
	}
	elseif ( !is_array($arr) ) {
		$out .= "Variable not an array<br>\n";
	}
	else {
		if ($depth == 0) {
			$out .= $prefix . ' ';
		}
		$out .= "Array(<br>\n";
		$tab = str_repeat('&nbsp;&nbsp;&nbsp;&nbsp;', $depth+1);
		foreach ($arr as $key=>$value) {
			if (!is_array($value)) {
				$out .= "$tab [$key] => [$value]<br>\n";
			}
			else {
				$out .= "$tab [$key] => ";
				$out .= html_print_r($prefix, $value, true, $depth + 1);
			}
		}
		$out .= "$tab)<br>\n";
	}
	
	if (!$return) {
		echo $out;
	}
	return $out;
}

function html_var_dump($var, $return=false) {
	ob_start();
	var_dump($var);
	$out = ob_get_contents();
	ob_end_clean();
	
	$out = "<pre style='background:white;  margin: 5px 5px 5px 5px; padding: 5px 5px 5px 5px; color:black;'>\n".$out;
	$out = str_replace("=>\n", "=>", $out);
	$out = ereg_replace('=>[ ]*', '=>', $out);
	$out = str_replace("\t", "  ", $out);
	
	if ($return) {
		return $out;
	}
	else {
		echo $out."</pre>";
	}
}
?>